Tetris
======

Implementierung des Puzzlespiels [Tetris](https://de.wikipedia.org/wiki/Tetris) (von [Alexei Paschitnow](https://de.wikipedia.org/wiki/Alexei_Leonidowitsch_Paschitnow)) für das SPiCboard mit OLED Display.


Eigenschaften
-------------

Für die Umsetzung wurde sich seht stark an der populären Version für den [Nintendo Game Boy](https://de.wikipedia.org/wiki/Game_Boy) (aus dem Jahre 1984) orientiert:

 * Verwendung der selben Grundfiguren bei den Spielsteinen
 * zwei SPiCboards können ebenfalls für einen rudimentären Mehrspielermodus miteinander verbunden werden (beim Auflösen von zwei oder mehr Zeilen erscheinen diese anschließend beim Gegner)
 * ähnliche [Berechnung der Punkte](http://tetris.wikia.com/wiki/Scoring)
 * persistente Bestenliste (gespeichert im [EEPROM](https://de.wikipedia.org/wiki/Electrically_Erasable_Programmable_Read-Only_Memory))
 * die 7-Segment-Anzeige gibt den darauffolgenden Figurstein an (nicht jedoch die Orientierung!)
 * 9 Level (mit zunehmender Fallgeschwindigkeit) entsprechend der Spielzeit
 * die Anzahl der aktivierten LEDs gibt das derzeitig erreichte Level an
 * eine (1-Pixel hohe) Statusbar am oberen Rand zeigt die Dauer bis zum nächsten Level an


Steuerung
---------

Im Spiel kann wird die Position mit dem Potentiometer festgelegt, mit `BUTTON1` (`PD3`) kann die Rotation (im Uhrzeigersinn) geändert werden und solange der Taster `BUTTON0`/`PD2` gedrückt ist, wird das Herabfallen der Figuren beschleunigt.

Für einen Eintrag in die Bestenliste kann mit dem Potentiometer der entsprechende Buchstabe des Namens ausgewählt werden (`A` - `Z` sowie Leerzeichen, Groß- und Kleinschreibung automatisch), `BUTTON0` für nächstes Zeichen, `BUTTON1` für vorheriges. Ende des Namens mit zwei Leerzeichen, maximal 16 Zeichen.


![Startbildschirm](./screenshot/tetris-1.png)
![Bestenliste](./screenshot/tetris-2.png)
![Im Spiels](./screenshot/tetris-3.png)
